/* **************************************************************** */
/* dsm.c, simple implementation of dsm                              */
/* For verifying test cases for cs 2/456 projects 4/5               */
/*                                                                  */
/* Copyright 2002, University of Rochester Department of Computer   */
/* Science; may be freely re-used provided that this header remains */
/* intact.                                                          */
/* **************************************************************** */
#define _XOPEN_SOURCE_EXTENDED 1
#define _XOPEN_SOURCE

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include "dsm.h"

static int memory[2048] = {0};

/*dsm_create(): create a block of shared memory*/
void dsm_create(int nPages, int pSize)
{
}

/*dsm_destroy(): destroys reference to shared memory*/
void dsm_destroy()
{
}

/* dsm_read(): read a value from shared memory */
/* param i: address (offset within shmem block) of memory to read */
/* param v: receives array of values read from memory; zeroed out if read fails */
/* param size: receives number of ints to be read*/
/* return: 0 for failure or 1 for success */
int dsm_read(int i, int *v, int size)
{
  int j;
  if (!v || i < 0 || i+size-1 > 2048)
    {
      if (v) {
	for (j=0; j<size; j++) v[j]=0;
      }
      return 0;
    }

  memcpy(v, memory+i, size*sizeof(int));
  return 1;
}

/* dsm_write() write an array of values into shared memory */
/* param i: address (offset within shmem block) of memory to write */
/* param v: contains reference to values to be written to shared memory */
/* param size: contains number of values to be written to shared memory */
/* return: 0 for failure or 1 for success */
int dsm_write(int i, int *v, int size)
{
  int *p;
  if (i < 0 || i+size-1 > 2048)
    return 0;

  memcpy(memory+i, v, size*sizeof(int));

  return 1;
}

/* EOF */















