/* **************************************************************** */
/* dsm.h, header for dsm methods                                    */
/* For use in cs256/456 projects 4 and 5                            */
/* Copyright 2002, University of Rochester Department of Computer   */
/* Science; may be freely re-used provided that this header remains */
/* intact.                                                          */
/* **************************************************************** */

#if !defined(__DSM_H__)
#define __DSM_H__

#if defined __cplusplus
extern "C" {
#endif

/*dsm_create(): create a block of shared memory*/
/* param nPages: number of pages in shared memory */
/* param pSize: the size of each individual page (in number of integers) */
  void dsm_create(int nPages, int pSize);

/*dsm_destroy(): destroys reference to shared memory*/
  void dsm_destroy();

/* dsm_read(): read a value from shared memory */
/* param i: address (offset within shmem block) of memory to read */
/* param v: receives value read from memory; zeroed out if read fails */
/* param size: receives number of ints to be read*/
/* return: 0 for failure or 1 for success */
  int dsm_read(int i, int *v, int size);

/* dsm_write() write an array of values into shared memory */
/* param i: address (offset within shmem block) of memory to write */
/* param v: contains reference to values to be written to shared memory */
/* param size: contains number of values to be written to shared memory */
/* return: 0 for failure or 1 for success */
  int dsm_write(int i, int *v, int size);

#if defined __cplusplus
}
#endif

#endif // __DSM_H__

/* EOF */
